// 进一步抽取共同js   （子组件共用代码抽取
import Vue from 'vue'
// import store from "@/store"

// 把dialogStore注册到store中
const dialogStore={
    namespaced:true,
    state:()=>({dialogs:{}}),
    mutations:{
        SHOW_DIALOG(state,dialog){
            // state.dialog=true
            Vue.set(state.dialogs,dialog,true)
          },
          HIDE_DIALOG(state,dialog){
            // state.dialog=false
            Vue.set(state.dialogs,dialog,false)
          }
    }
}
// 打包后store冲突
// if(!store.hasModule("dialog")){
//     store.registerModule("dialog",dialogStore)
// }

const installStore=function(store){
    if(!store.hasModule("dialog")){
        store.registerModule("dialog",dialogStore)
    }
}


const dialogMixin={
    data() {
        return {
            dialog:false,
            dialogName:"_"+Math.random().toString(36).substring(2,9)   //字母数字的集合
        }
    },
    methods: {
        showDialog(){
            this.$store.commit('dialog/SHOW_DIALOG',this.dialogName)
        },
        hideDialog(){
            this.$store.commit('dialog/HIDE_DIALOG',this.dialogName)
        }
    },
    computed:{
        dialogState(){
            return this.$store.state.dialog.dialogs[this.dialogName]
        }
    },
    watch:{
        dialogState(newValue){
            this.dialog=newValue?true:false
        }
    }
}

export {
    dialogMixin,
    installStore
}





